// Copyright (c)1999-2001 by "GMD-AiS"
//  Full name: "GMD National Research Center for Information Technology -
//  Institute for Autonomous Intelligent Systems", in future
//  named "Fraunhofer Institute for Autonomous Intelligent Systems"
//
// This software is provided 'as is' by the above copyright holder without
// any explicit or implicit warranty and support.
//
// Within the granted license, the licensee is allowed to freely use
// and modify the software EXCLUSIVELY FOR academical, SCIENTIFIC, and/or
// educational PURPOSES. It is permitted to cite (in the common scientific
// sense) fragments of the code in scientific publications of the licensee,
// and also use modified or unmodified parts of the software in own
// research prototypes.
//
// Commerical use, as well as integration into hardware/software systems or
// other products, other then for aforementioned scientific purposes, is
// PROHIBITED WITHOUT EXPLICIT PERMISSION of the copyright holder.
//
// Prototyping software that makes use of parts of this code have to
// refer to the above copyright when given out to third parties by
// a line
//   "This software contains or uses code that is copyrighted
//    by the GMD National Research Center for Information Technology
//    (Fraunhofer Institute for Autonomous Intelligent Systems)"
// in the user visible part of the software (documentation, about box, etc.)
//
// The copyright holder provides the software 'as is' without any support
// (request for bugfixes, for instance), and without any implicit or explicit
// warranty. In particular, the copyright holder cannot be made liable
// for lack of certain features, for damages of any kind that might result
// from any proper or improper use of this software. This software is not
// to be used in safety-critical environments.
//
// Beyond this license, GMD-AiS appreciates, in the scientific sense,
// reports and code submissions of significant changes or improvements
// of the jFTA core software that might be integrated into a future
// version of this code. Such reports are entirely voluntary, though;
// they are not mandated by this license. Use the address jfta@borneo.gmd.de
// (in future jfta@borneo.ais.fhg.de) for submissions.

// This is a template for an own init actor type
// insert stuff at all locations that have [ xxxxx ]
// by default, this file cannot be compiled.
// $Id: InitActorTemplate.java,v 1.2 2001/06/21 14:57:09 veit Exp $


package [MYPACKAGE];

import jfta.exception.*;
import jfta.tags.*;
import jfta.actors.*;

[MYPACKAGES_TO_IMPORT];

/**
  * This init actor does [DESCRIPTION]
  * @author [AUTHOR]
  * @version $Id: InitActorTemplate.java,v 1.2 2001/06/21 14:57:09 veit Exp $
  */
public class [MYACTOR] extends FTAInitActor implements FTAActorI {

  /**
    * [ADD ATTRIBUTES HERE.
    * MAKE THEM PRIVATE OR PROTECTED]
    */
  [ATTRIBUTES];
  
  /**
    * [ADD OWN METHODS HERE.
    * MAKE THEM PRIVATE OR PROTECTED]
    */
  [METHODS];
  
  /**
    * [IMPLEMENT THIS ROUTINE (MANDATORY)]
    * @return FTAActor.TERMINATE if the actor terminates after this
    *   routine has been called, FTAActor.KEEPALIVE to have the actor
    *   be rescheduled in the next tick cycle.
    * @exception FTAEvalActorException thrown in case a fatal error occurred
    */
  public int eval() throws FTAEvalActorException {
    try {
	// [add new host(s)]
	addHost([host]);

	// [add new tagboard(s)]
	addTagboard([TBNAME],[HOST],[DIST/NONDIST]);

	// [add new ensemble(s)]
	addEnsemble([ENNAME],[HOST],[DIST/NONDIST]);

	// [add actors to ensemble(s)]
	String[] acargs = { [ARGS] };
	addActor([HOST],[ENNAME],[ACNAME],[ACTYPE],acargs);

	// [add tags to tagboard(s)]
	String[] tgargs = { [ARGS] };
	putTag([TBNAME],[TGTYPE],tgargs);

	// [add ET synchronization]
	addETSync([ENNAME],[TBNAME]);

	// [add EE synchronization]
	FTARatio ratio = [RATIO];
	addETSync([ENNAME1],[ENNAME2],ratio);
    }
    catch(FTAException e) {
      [EVAL_EXCEPTION];
    }
  }
  
  /**
    * [IMPLEMENT THIS METHOD TO PARSE ARGUMENTS AND FINALLY INITIALIZE
    * THE TAG. YOU MUST IMPLEMENT THIS METHOD (MANDATORY)]
    * @param args list of arguments passed by <code>addActor</code> to the
    *   newly created actor. 
    * @exception FTAArgumentException to be thrown by the user code if some
    *   argument is incoreect for this type of actor
    * @return returns true, if the initialization was okay, false if there
    *   has been a problem not requiring an <code>FTAArgumentException</code>
    */
  public void init(String[] args) throws FTAArgumentException {
    [INIT_IMPLEMENTATION];
  }
  
  /**
    * [IMPLEMENT THIS *EMPTY* CONSTRUCTOR (MANDATORY)]
    */
  public [MYACTOR]() {
    super();
    [INIT_ATTRIBUTES];
  }
}
