// Copyright (c)1999-2001 by "GMD-AiS"
//  Full name: "GMD National Research Center for Information Technology -
//  Institute for Autonomous Intelligent Systems", in future
//  named "Fraunhofer Institute for Autonomous Intelligent Systems"
//
// This software is provided 'as is' by the above copyright holder without
// any explicit or implicit warranty and support.
//
// Within the granted license, the licensee is allowed to freely use
// and modify the software EXCLUSIVELY FOR academical, SCIENTIFIC, and/or
// educational PURPOSES. It is permitted to cite (in the common scientific
// sense) fragments of the code in scientific publications of the licensee,
// and also use modified or unmodified parts of the software in own
// research prototypes.
//
// Commerical use, as well as integration into hardware/software systems or
// other products, other then for aforementioned scientific purposes, is
// PROHIBITED WITHOUT EXPLICIT PERMISSION of the copyright holder.
//
// Prototyping software that makes use of parts of this code have to
// refer to the above copyright when given out to third parties by
// a line
//   "This software contains or uses code that is copyrighted
//    by the GMD National Research Center for Information Technology
//    (Fraunhofer Institute for Autonomous Intelligent Systems)"
// in the user visible part of the software (documentation, about box, etc.)
//
// The copyright holder provides the software 'as is' without any support
// (request for bugfixes, for instance), and without any implicit or explicit
// warranty. In particular, the copyright holder cannot be made liable
// for lack of certain features, for damages of any kind that might result
// from any proper or improper use of this software. This software is not
// to be used in safety-critical environments.
//
// Beyond this license, GMD-AiS appreciates, in the scientific sense,
// reports and code submissions of significant changes or improvements
// of the jFTA core software that might be integrated into a future
// version of this code. Such reports are entirely voluntary, though;
// they are not mandated by this license. Use the address jfta@borneo.gmd.de
// (in future jfta@borneo.ais.fhg.de) for submissions.

// $Id: FTAListenerAdapter.java,v 1.10 2001/06/21 14:57:09 veit Exp $

package jfta.base;

import jfta.actors.*;
import jfta.tags.*;
import jfta.base.*;

public class FTAListenerAdapter implements FTAListenerI {

    public void uninstall(FTACommManager comm) {}

    public void initdone(FTACommManager comm) {}

    public void notifyCreateHost(String hostname) {
	System.out.println(this+": unimplemented CREATEHOST handler");
    }

    public void notifyCreateHostDone(int hostnum,String hostname,int port) {
	System.out.println(this+": unimplemented CREATEHOSTDONE handler");
    }

    public void notifyCreateTB(String hostname,String logname) {
	System.out.println(this+": unimplemented CREATETB handler");
    }

    public void notifyCreateTBDone(int tbnum,String hostname,
				   String logname,int myport) {
	System.out.println(this+": unimplemented CREATETBDONE handler");
    }

    public void notifyCreateTBOfficeDone(int host) {
	System.out.println(this+": unimplemented CREATETBOFFICEDONE handler");
    }
    public void notifyCreateEN(String hostname,String logname) {
	System.out.println(this+": unimplemented CREATEEN handler");
    }

    public void notifyCreateENDone(int ennum,String hostname,
				   String logname,int myport) {
	System.out.println(this+": unimplemented CREATEENDONE handler");
    }

    public void notifyCreateENOfficeDone(int host) {
	System.out.println(this+": unimplemented CREATEENOFFICEDONE handler");
    }

    public void notifyControl(int function, int type) {
	System.out.println(this+": unimplemented CONTROL handler");
    }

    public void notifyRemoveHost(int hostnum) {
	System.out.println(this+": unimplemented REMOVEHOST handler");
    }

    public void notifyRemoveTB(int tbnum) {
	System.out.println(this+": unimplemented REMOVETB handler");
    }

    public void notifyRemoveEN(int ennum) {
	System.out.println(this+": unimplemented REMOVEEN handler");
    }

    public void notifyStartCycle(long cyc,long millis) {
	System.out.println(this+": unimplemented STARTCYCLE handler");
    }

    public void notifyAckCycle(int officenum,long cyc,boolean fin) {
	System.out.println(this+": unimplemented ACKCYCLE handler");
    }

    public void notifyFlipOrderReq(int tbnum) {
	System.out.println(this+": unimplemented FLIPORDERREQ handler");
    }

    public void notifyFlipOrder(int ennum) {
	System.out.println(this+": unimplemented FLIPORDER handler");
    }

    public void notifyAddETSync(int ennum,int tbnum) {
	System.out.println(this+": unimplemented ADETSYNC handler");
    }

    public void notifyRemoveETSync(int ennum,int tbnum) {
	System.out.println(this+": unimplemented REMOVEETSYNC handler");
    }

    public void notifyAddActor(int ennum,FTAActor actor) {
	System.out.println(this+": unimplemented ADDACTOR handler");
    }

    public void notifyPutTag(FTATag tag) {
	System.out.println(this+": unimplemented PUTTAG handler");
    }

    public void notifyCycle(int ennum) {
	System.out.println(this+": unimplemented CYCLE handler");
    }

    public void notifyConsent(int ennum) {
	System.out.println(this+": unimplemented CONSENT handler");
    }

    public void notifyPreFlip(int tbnum) {
	System.out.println(this+": unimplemented PREFLIP handler");
    }

    public void notifyPostFlip(int tbnum) {
	System.out.println(this+": unimplemented POSTFLIP handler");
    }

    public void notifyFtadDaemonIdRequest(long time) {
	System.out.println(this+": unimplemented FTAD_DAEMONREQ handler");
    }

    public void notifyFtadDaemonIdReply(long time,String host) {
	System.out.println(this+": unimplemented FTAD_DAEMONREPLY handler");
    }

    public void notifyFtadSystemIdRequest(long time) {
	System.out.println(this+": unimplemented FTAD_SYSTEMREQ handler");
    }

    public void notifyFtadSystemIdReply(long time,String host) {
	System.out.println(this+": unimplemented FTAD_SYSTEMREPLY handler");
    }

    public void notifyFtadDirIdRequest(long time) {
	System.out.println(this+": unimplemented FTAD_DIRREQ handler");
    }

    public void notifyFtadDirIdReply(long time,String url) {
	System.out.println(this+": unimplemented FTAD_DIRREPLY handler");
    }

    public void notifyFtadShutdown() {
	System.out.println(this+": unimplemented FTAD_SHUTDOWN handler");
    }

    public void notifyLogMessage(int type,String msg) {
	System.out.println(this+": unimplemented LOG_MESSAGE handler");
    }

    public void notifyAddHost(int hostnum, String host,int port) {
	System.out.println(this+": unimplemented ADDHOST handler");
    }
}

/*
 * Local variables: 
 * tab-width: 8
 * c-basic-offset: 4
 * End: 
 */
