// Copyright (c)1999-2001 by "GMD-AiS"
//  Full name: "GMD National Research Center for Information Technology -
//  Institute for Autonomous Intelligent Systems", in future
//  named "Fraunhofer Institute for Autonomous Intelligent Systems"
//
// This software is provided 'as is' by the above copyright holder without
// any explicit or implicit warranty and support.
//
// Within the granted license, the licensee is allowed to freely use
// and modify the software EXCLUSIVELY FOR academical, SCIENTIFIC, and/or
// educational PURPOSES. It is permitted to cite (in the common scientific
// sense) fragments of the code in scientific publications of the licensee,
// and also use modified or unmodified parts of the software in own
// research prototypes.
//
// Commerical use, as well as integration into hardware/software systems or
// other products, other then for aforementioned scientific purposes, is
// PROHIBITED WITHOUT EXPLICIT PERMISSION of the copyright holder.
//
// Prototyping software that makes use of parts of this code have to
// refer to the above copyright when given out to third parties by
// a line
//   "This software contains or uses code that is copyrighted
//    by the GMD National Research Center for Information Technology
//    (Fraunhofer Institute for Autonomous Intelligent Systems)"
// in the user visible part of the software (documentation, about box, etc.)
//
// The copyright holder provides the software 'as is' without any support
// (request for bugfixes, for instance), and without any implicit or explicit
// warranty. In particular, the copyright holder cannot be made liable
// for lack of certain features, for damages of any kind that might result
// from any proper or improper use of this software. This software is not
// to be used in safety-critical environments.
//
// Beyond this license, GMD-AiS appreciates, in the scientific sense,
// reports and code submissions of significant changes or improvements
// of the jFTA core software that might be integrated into a future
// version of this code. Such reports are entirely voluntary, though;
// they are not mandated by this license. Use the address jfta@borneo.gmd.de
// (in future jfta@borneo.ais.fhg.de) for submissions.

// $Id: FTAListenerI.java,v 1.10 2001/06/21 14:57:09 veit Exp $

package jfta.base;

import jfta.tags.*;
import jfta.actors.*;

public interface FTAListenerI {

    public void uninstall(FTACommManager comm);
    public void initdone(FTACommManager comm);

    public void notifyCreateHost(String hostname);
    public void notifyCreateHostDone(int hostnum,
				     String host,int port);
    public void notifyCreateTB(String hostname,String logname);
    public void notifyCreateTBDone(int tbnum,String hostname,
				   String logname,int myport);
    public void notifyCreateTBOfficeDone(int host);
    public void notifyCreateEN(String hostname,String logname);
    public void notifyCreateENDone(int tbnum,String hostname,
				   String logname,int myport);
    public void notifyCreateENOfficeDone(int host);
    public void notifyControl(int function, int type);
    public void notifyRemoveHost(int hostnum);
    public void notifyRemoveTB(int tbnum);
    public void notifyRemoveEN(int ennum);
    public void notifyStartCycle(long cyc,long millis);
    public void notifyAckCycle(int officenum,long cyc,boolean fin);
    public void notifyFlipOrderReq(int tbnum);
    public void notifyFlipOrder(int ennum);
    public void notifyAddETSync(int ennum,int tbnum);
    public void notifyRemoveETSync(int ennum,int tbnum);
    public void notifyAddActor(int ennum,FTAActor actor);
    public void notifyPutTag(FTATag tag);
    public void notifyCycle(int ennum);
    public void notifyConsent(int ennum);
    public void notifyPreFlip(int tbnum);
    public void notifyPostFlip(int tbnum);
    public void notifyFtadDaemonIdRequest(long time);
    public void notifyFtadDaemonIdReply(long time,String info);
    public void notifyFtadSystemIdRequest(long time);
    public void notifyFtadSystemIdReply(long time,String info);
    public void notifyFtadDirIdRequest(long time);
    public void notifyFtadDirIdReply(long time,String info);
    public void notifyFtadShutdown();
    public void notifyLogMessage(int type,String msg);
    public void notifyAddHost(int hostnum,String hostname,int port);
}

/*
 * Local variables: 
 * tab-width: 8
 * c-basic-offset: 4
 * End: 
 */
