// Copyright (c)1999-2001 by "GMD-AiS"
//  Full name: "GMD National Research Center for Information Technology -
//  Institute for Autonomous Intelligent Systems", in future
//  named "Fraunhofer Institute for Autonomous Intelligent Systems"
//
// This software is provided 'as is' by the above copyright holder without
// any explicit or implicit warranty and support.
//
// Within the granted license, the licensee is allowed to freely use
// and modify the software EXCLUSIVELY FOR academical, SCIENTIFIC, and/or
// educational PURPOSES. It is permitted to cite (in the common scientific
// sense) fragments of the code in scientific publications of the licensee,
// and also use modified or unmodified parts of the software in own
// research prototypes.
//
// Commerical use, as well as integration into hardware/software systems or
// other products, other then for aforementioned scientific purposes, is
// PROHIBITED WITHOUT EXPLICIT PERMISSION of the copyright holder.
//
// Prototyping software that makes use of parts of this code have to
// refer to the above copyright when given out to third parties by
// a line
//   "This software contains or uses code that is copyrighted
//    by the GMD National Research Center for Information Technology
//    (Fraunhofer Institute for Autonomous Intelligent Systems)"
// in the user visible part of the software (documentation, about box, etc.)
//
// The copyright holder provides the software 'as is' without any support
// (request for bugfixes, for instance), and without any implicit or explicit
// warranty. In particular, the copyright holder cannot be made liable
// for lack of certain features, for damages of any kind that might result
// from any proper or improper use of this software. This software is not
// to be used in safety-critical environments.
//
// Beyond this license, GMD-AiS appreciates, in the scientific sense,
// reports and code submissions of significant changes or improvements
// of the jFTA core software that might be integrated into a future
// version of this code. Such reports are entirely voluntary, though;
// they are not mandated by this license. Use the address jfta@borneo.gmd.de
// (in future jfta@borneo.ais.fhg.de) for submissions.

// $Id: FTAListenerList.java,v 1.6 2001/06/21 14:57:10 veit Exp $

package jfta.base;

import jfta.actors.*;
import jfta.tags.*;
import jfta.exception.*;

public class FTAListenerList {

    private FTAListenerItem _elems[];

    public FTAListenerList() {
	int n = FTAMsg.MAX_MESSAGE;
	_elems = new FTAListenerItem[n];
	for (int i=0; i<n; i++)
	    _elems[i] = null;
    }

    /*package*/ FTAListenerItem first(int msg) {
	return _elems[msg];
    }

    public synchronized void addListener(int msg,
					 FTAListenerI listener,
					 int filter) {
	if (FTADebug.MR)
	    FTADebug.log(-1,filter,
			 "Register " + FTAMsg.getTypeNum(msg) +
			 " for " + listener + " filter=" + filter);

	_elems[msg] = new FTAListenerItem(listener,filter,
					  _elems[msg]);
    }

    public synchronized void removeListener(int msg,
					    FTAListenerI listener) {
	FTAListenerItem root = _elems[msg];
	if (root==null) return;
	else if (root.listener == listener)
	    _elems[msg] = root.next;
        else {
	    FTAListenerItem next = root.next;
            while (next != null) {
		if (next.listener == listener) {
		    root.next = next.next;
                    return;
                } else {
                    root = next;
		    next = root.next;
                }
            }
	}
    }
}

/*
 * Local variables: 
 * tab-width: 8
 * c-basic-offset: 4
 * End: 
 */
