// Copyright (c)1999-2001 by "GMD-AiS"
//  Full name: "GMD National Research Center for Information Technology -
//  Institute for Autonomous Intelligent Systems", in future
//  named "Fraunhofer Institute for Autonomous Intelligent Systems"
//
// This software is provided 'as is' by the above copyright holder without
// any explicit or implicit warranty and support.
//
// Within the granted license, the licensee is allowed to freely use
// and modify the software EXCLUSIVELY FOR academical, SCIENTIFIC, and/or
// educational PURPOSES. It is permitted to cite (in the common scientific
// sense) fragments of the code in scientific publications of the licensee,
// and also use modified or unmodified parts of the software in own
// research prototypes.
//
// Commerical use, as well as integration into hardware/software systems or
// other products, other then for aforementioned scientific purposes, is
// PROHIBITED WITHOUT EXPLICIT PERMISSION of the copyright holder.
//
// Prototyping software that makes use of parts of this code have to
// refer to the above copyright when given out to third parties by
// a line
//   "This software contains or uses code that is copyrighted
//    by the GMD National Research Center for Information Technology
//    (Fraunhofer Institute for Autonomous Intelligent Systems)"
// in the user visible part of the software (documentation, about box, etc.)
//
// The copyright holder provides the software 'as is' without any support
// (request for bugfixes, for instance), and without any implicit or explicit
// warranty. In particular, the copyright holder cannot be made liable
// for lack of certain features, for damages of any kind that might result
// from any proper or improper use of this software. This software is not
// to be used in safety-critical environments.
//
// Beyond this license, GMD-AiS appreciates, in the scientific sense,
// reports and code submissions of significant changes or improvements
// of the jFTA core software that might be integrated into a future
// version of this code. Such reports are entirely voluntary, though;
// they are not mandated by this license. Use the address jfta@borneo.gmd.de
// (in future jfta@borneo.ais.fhg.de) for submissions.

package jfta.demo.ping;

import java.util.*;
import jfta.actors.FTAActor;
import jfta.tags.*;
import jfta.exception.*;

public class TDContainer{
private Hashtable tagboards;

    protected TDContainer(){
	tagboards = new Hashtable();
    }

    protected void add(String name,String use, FTAActor ref){
	tagboards.put(name, new TagboardData(name,use,ref));
    }
    
    protected void remove(String name){
	tagboards.remove(name);
    }

    protected void putTag(String tagname,String[] msgs)
	throws TagboardDataUnknownException,FTATagException,
	       FTAUnknownObjectException,FTAArgumentException
    {
	Enumeration enum = tagboards.elements();
	boolean found = false;
	TagboardData td;
	while(enum.hasMoreElements()){
	    td = (TagboardData) enum.nextElement();
	    if((td.getType()).equals("write")){
		td.putTag(tagname,msgs);
		found = true;
	    }
	}
	if(!found) 
	    throw new TagboardDataUnknownException();
    }
    
    private TagboardData get(String name){
	return (TagboardData) tagboards.get(name);
    }

    protected void putTag(String tbname,String tagname,String[] msgs)
	throws TagboardDataUnknownException ,FTATagException,
	       FTAUnknownObjectException,FTAArgumentException
    {
	TagboardData td = get(tbname);
	if(td != null)
	    td.putTag(tagname,msgs);
	else
	    throw new TagboardDataUnknownException();
    }

    protected Vector getIteratorVector(FTATagPattern pat)
	throws FTAUnknownObjectException,FTAArgumentException
    {
	Vector vector = new Vector();
	Enumeration enum = tagboards.elements();
	TagboardData td;
	while(enum.hasMoreElements()){
	    td = (TagboardData) enum.nextElement();
	    if((td.getType()).equals("read"))
		vector.add(td.getTagIterator(pat));
	}
	return vector;
    }
    
    protected FTATagIterator getTagIterator(String tbname, FTATagPattern pat)
	throws TagboardDataUseException,TagboardDataUnknownException,
	       FTAUnknownObjectException,FTAArgumentException
    {
	TagboardData td = get(tbname);
	if(td != null)
	    {
		if((td.getType()).equals("read"))
		    return td.getTagIterator(pat);
		else
		    throw new TagboardDataUseException();
	    }
	else 
	    throw new TagboardDataUnknownException();
    }
    
    protected Enumeration getNames(){
	return tagboards.keys();
    }

    protected boolean hasFlipped(String tbname)
	throws TagboardDataUnknownException,FTAUnknownObjectException,
	       FTAArgumentException
    {
	TagboardData td = get(tbname);
	if(td != null)
	    return td.hasFlipped();
	else
	    throw new TagboardDataUnknownException();
    }
}
