// Copyright (c)1999-2001 by "GMD-AiS"
//  Full name: "GMD National Research Center for Information Technology -
//  Institute for Autonomous Intelligent Systems", in future
//  named "Fraunhofer Institute for Autonomous Intelligent Systems"
//
// This software is provided 'as is' by the above copyright holder without
// any explicit or implicit warranty and support.
//
// Within the granted license, the licensee is allowed to freely use
// and modify the software EXCLUSIVELY FOR academical, SCIENTIFIC, and/or
// educational PURPOSES. It is permitted to cite (in the common scientific
// sense) fragments of the code in scientific publications of the licensee,
// and also use modified or unmodified parts of the software in own
// research prototypes.
//
// Commerical use, as well as integration into hardware/software systems or
// other products, other then for aforementioned scientific purposes, is
// PROHIBITED WITHOUT EXPLICIT PERMISSION of the copyright holder.
//
// Prototyping software that makes use of parts of this code have to
// refer to the above copyright when given out to third parties by
// a line
//   "This software contains or uses code that is copyrighted
//    by the GMD National Research Center for Information Technology
//    (Fraunhofer Institute for Autonomous Intelligent Systems)"
// in the user visible part of the software (documentation, about box, etc.)
//
// The copyright holder provides the software 'as is' without any support
// (request for bugfixes, for instance), and without any implicit or explicit
// warranty. In particular, the copyright holder cannot be made liable
// for lack of certain features, for damages of any kind that might result
// from any proper or improper use of this software. This software is not
// to be used in safety-critical environments.
//
// Beyond this license, GMD-AiS appreciates, in the scientific sense,
// reports and code submissions of significant changes or improvements
// of the jFTA core software that might be integrated into a future
// version of this code. Such reports are entirely voluntary, though;
// they are not mandated by this license. Use the address jfta@borneo.gmd.de
// (in future jfta@borneo.ais.fhg.de) for submissions.

package jfta.demo.simrob;

import jfta.base.*;
import jfta.exception.*;
import jfta.tags.*;
import jfta.actors.*;

import java.io.*;
import java.util.*;
import java.awt.*;
// Copyright (c)1999-2001 by "GMD-AiS"
//  Full name: "GMD National Research Center for Information Technology -
//  Institute for Autonomous Intelligent Systems", in future
//  named "Fraunhofer Institute for Autonomous Intelligent Systems"
//
// This software is provided 'as is' by the above copyright holder without
// any explicit or implicit warranty and support.
//
// Within the granted license, the licensee is allowed to freely use
// and modify the software EXCLUSIVELY FOR academical, SCIENTIFIC, and/or
// educational PURPOSES. It is permitted to cite (in the common scientific
// sense) fragments of the code in scientific publications of the licensee,
// and also use modified or unmodified parts of the software in own
// research prototypes.
//
// Commerical use, as well as integration into hardware/software systems or
// other products, other then for aforementioned scientific purposes, is
// PROHIBITED WITHOUT EXPLICIT PERMISSION of the copyright holder.
//
// Prototyping software that makes use of parts of this code have to
// refer to the above copyright when given out to third parties by
// a line
//   "This software contains or uses code that is copyrighted
//    by the GMD National Research Center for Information Technology
//    (Fraunhofer Institute for Autonomous Intelligent Systems)"
// in the user visible part of the software (documentation, about box, etc.)
//
// The copyright holder provides the software 'as is' without any support
// (request for bugfixes, for instance), and without any implicit or explicit
// warranty. In particular, the copyright holder cannot be made liable
// for lack of certain features, for damages of any kind that might result
// from any proper or improper use of this software. This software is not
// to be used in safety-critical environments.
//
// Beyond this license, GMD-AiS appreciates, in the scientific sense,
// reports and code submissions of significant changes or improvements
// of the jFTA core software that might be integrated into a future
// version of this code. Such reports are entirely voluntary, though;
// they are not mandated by this license. Use the address jfta@borneo.gmd.de
// (in future jfta@borneo.ais.fhg.de) for submissions.

/**
  * This actor manages map installation
  * @author Holger Veit, Andre Schmitz, Frank Schoenherr
  * @version $Id: MapLoader.java,v 1.2 2001/06/21 14:57:18 veit Exp $
  */
public class MapLoader extends FTAActor implements FTAActorI,Constants {

    private Color[] colors;
    private Color doorcolor2 = null;
    private int[] widths;
    private final static FTAService _svc = FTAService.Instance();

    private boolean defaultset = true;
    private String defcolor;
    private String defwidth;

    /**
     */
    private FTATBCallback cb;

    /**
     * @serial available commands in map file
     */
    private static Hashtable mapcmds = null;


    /**
     * helper method
     */
    private Color getColor(int n) {
	return colors[n];
    }

    /**
     * helper method
     */
    private int getWidth(int n) {
	return widths[n];
    }

    /**
     * handle the MAP command
     * syntax: MAP "filename"
     */
    private class MapCmd extends Object implements LineParse {
	public boolean read(StreamTokenizer st,Object obj)
	    throws LineParserException {
	    // ignore
	    return true;
	}
    }
  
    /**
     * handle the DIMENSION command
     * syntax: DIMENSION X Y
     */
    private class DimCmd extends Object implements LineParse {
	public boolean read(StreamTokenizer st,Object obj)
	    throws LineParserException {
	    try {
		FTAActor ac = (FTAActor)obj;
		int x = LineParser.getInt(st);
		int y = LineParser.getInt(st);
		ac.putTag(enviTB, 
			  new MapSwallObjTag(getColor(7),getWidth(7),x,y));
	    }
	    catch (FTAException e) {
		LineParser.exception(st,"Expected numeric X Y");
	    }
	    return true;
	}
    }

    /**
     * handle the LINE command
     * syntax: LINE x y x1 y1
     */
    private class LineCmd extends Object implements LineParse {
	public boolean read(StreamTokenizer st,Object obj)
	    throws LineParserException {
	    try {
		MapLoader ac = (MapLoader)obj;
		String name = LineParser.getString(st,false);
		int x1 = LineParser.getInt(st);
		int y1 = LineParser.getInt(st);
		int x2 = LineParser.getInt(st);
		int y2 = LineParser.getInt(st);
		putTag(enviTB,
		       new MapLineObjTag(name,getColor(1),getWidth(1),x1,y1,x2,y2));
	    }
	    catch (FTAEvalActorException e) {
		LineParser.exception(st,e.getMessage());
	    }
	    return true;
	}
    }

    /**
     * handle the DOOR command
     * syntax: DOOR x y x1 y1
     * looks like a line, but is moveable (not implemented yet!)
     */
    private class DoorCmd extends Object implements LineParse {
	public boolean read(StreamTokenizer st,Object obj)
	    throws LineParserException {
	    try {
		MapLoader ac = (MapLoader)obj;
		String name = LineParser.getString(st,false);
		int x1 = LineParser.getInt(st);
		int y1 = LineParser.getInt(st);
		int x2 = LineParser.getInt(st);
		int y2 = LineParser.getInt(st);
		int angle = LineParser.getInt(st);
		boolean open = LineParser.getInt(st)==1;
		if (doorcolor2 == null) {
		    doorcolor2 = _svc.getColorProperty("door_color_open",Color.green);
		}
		putTag(enviTB,
		       new MapDoorObjTag(name,getColor(6),getWidth(6),doorcolor2,
					 x1,y1,x2,y2,angle,open));
	    }
	    catch (FTAEvalActorException e) {
		LineParser.exception(st,e.getMessage());
	    }
	    return true;
	}
    }

    /**
     * handle the QUAD command
     * syntax: QUAD x y x1 y1 x2 y2 x3 y3
     */
    private class QuadCmd extends Object implements LineParse {
	public boolean read(StreamTokenizer st,Object obj)
	    throws LineParserException {
	    try {
		MapLoader ac = (MapLoader)obj;
		String name = LineParser.getString(st,false);
		int[] xp = new int[4];
		int[] yp = new int[4];
		for (int i=0; i<4; i++) {
		    xp[i] = LineParser.getInt(st);
		    yp[i] = LineParser.getInt(st);
		}
		putTag(enviTB,
		       new MapQuadObjTag(name,getColor(4),getWidth(4),xp,yp));
	    }
	    catch (FTAEvalActorException e) {
		LineParser.exception(st,e.getMessage());
	    }
	    return true;
	}
    }

    /**
     * handle the TRI command
     * syntax: TRI x y x1 y1 x2 y2
     */
    private class TriCmd extends Object implements LineParse {
	public boolean read(StreamTokenizer st,Object obj)
	    throws LineParserException {
	    try {
		MapLoader ac = (MapLoader)obj;
		String name = LineParser.getString(st,false);
		int[] xp = new int[3];
		int[] yp = new int[3];
		for (int i=0; i<3; i++) {
		    xp[i] = LineParser.getInt(st);
		    yp[i] = LineParser.getInt(st);
		}
		putTag(enviTB,
		       new MapTriObjTag(name,getColor(5),getWidth(5),xp,yp));
	    }
	    catch (FTAEvalActorException e) {
		LineParser.exception(st,e.getMessage());
	    }
	    return true;
	}
    }

    /**
     * handle the WALL command
     * syntax: WALL x y x1 y1
     */
    private class WallCmd extends Object implements LineParse {
	public boolean read(StreamTokenizer st,Object obj)
	    throws LineParserException {
	    try {
		MapLoader ac = (MapLoader)obj;
		String name = LineParser.getString(st,false);
		int x1 = LineParser.getInt(st);
		int y1 = LineParser.getInt(st);
		int x2 = LineParser.getInt(st);
		int y2 = LineParser.getInt(st);
		putTag(enviTB,
		       new MapWallObjTag(name,getColor(2),getWidth(2),
					 x1,y1,x2,y2));
	    }
	    catch (FTAEvalActorException e) {
		LineParser.exception(st,e.getMessage());
	    }
	    return true;
	}
    }

    /**
     * handle the Circle command
     * syntax: CIRCLE x y rad
     */
    private class CircleCmd extends Object implements LineParse {
	public boolean read(StreamTokenizer st,Object obj)
	    throws LineParserException {
	    try {
		MapLoader ac = (MapLoader)obj;
		String name = LineParser.getString(st,false);
		int x1 = LineParser.getInt(st);
		int y1 = LineParser.getInt(st);
		int dia = LineParser.getInt(st);
		putTag(enviTB,
		       new MapCircleObjTag(name,getColor(3),getWidth(3),
					   x1,y1,dia));
	    }
	    catch (FTAEvalActorException e) {
		LineParser.exception(st,e.getMessage());
	    }
	    return true;
	}
    }

    /**
     * handle the POLY command
     * syntax: POLY n {x y}*n
     */
    private class PolyCmd extends Object implements LineParse {
	public boolean read(StreamTokenizer st,Object obj)
	    throws LineParserException {
	    try {
		MapLoader ac = (MapLoader)obj;
		String name = LineParser.getString(st,false);
		int n = LineParser.getInt(st);
		int[] xp = new int[n];
		int[] yp = new int[n];
		for (int i=0; i<n; i++) {
		    xp[i] = LineParser.getInt(st);
		    yp[i] = LineParser.getInt(st);
		}
		putTag(enviTB,
		       new MapPolyObjTag(name,getColor(9),getWidth(9),
					 n,xp,yp));
	    }
	    catch (FTAEvalActorException e) {
		LineParser.exception(st,e.getMessage());
	    }
	    return true;
	}
    }

    /**
     * handle the END command
     * syntax: END
     */
    private class EndCmd extends Object implements LineParse {
	public boolean read(StreamTokenizer st,Object obj)
	    throws LineParserException {
       
	    MapLoader ac = (MapLoader)obj;
	    try {
		ac.flipOrder(enviTB);
	    }
	    catch (FTAEvalActorException e) {
		LineParser.exception(st,e.getMessage());
	    }
	    return false;
	}
    }

    private boolean LoadMap(String filename) {
	try {
	    LineParser dummyvar = new LineParser(filename,this,mapcmds);
	    return true;
	}
	catch(FileNotFoundException e) {
	    userMessage("MapLoader","File not found: "+ filename);
	    return false;
	}
	catch(LineParserException e) {
	    userMessage("MapLoader","Parser error:" + e.getMessage());
	    return false;
	}
    }

    /**
     * msg tagboard reader
     */
    private class MsgCallback extends FTATBCallback {
	public MsgCallback(FTAActor ac) {
	    super(ac,msgTB);
	}
	public int eval2() throws FTAEvalActorException {
	    FTATagIterator iter = getTagIterator(tb,msgpattern);
	    String filename; 
	    while (iter.hasNext()) {
		Object tag = iter.next();
		if (tag instanceof MsgLoadMapTag) {
		    MsgLoadMapTag mt = (MsgLoadMapTag)tag;
		    filename = mt.getFile();
		    LoadMap(filename);
		} else if (tag instanceof MsgTerminateTag) {
		    userMessage("MapLoader","EXITING...");
		    return FTAActor.TERMINATE;
		}
	    }
	    return KEEPALIVE;
	}
    }

    /**
     * mandatory eval method
     * @return TERMINATE if the actor terminates after this
     *   routine has been called, KEEPALIVE to have the actor
     *   be rescheduled in the next tick cycle.
     * @exception FTAEvalActorException thrown in case a fatal error occurred
     */
    public int eval() throws FTAEvalActorException {
	return cb.eval();
    }
  
    /**
     * mandatory init method
     * @param args list of arguments passed by <code>addActor</code> to the
     *   newly created actor. 
     * @exception FTAArgumentException to be thrown by the user code if some
     *   argument is incorrect for this type of actor
     * @return returns true, if the initialization was okay, false if there
     *   has been a problem not requiring an <code>FTAArgumentException</code>
     */
    public void init(String[] args) throws FTAArgumentException {
	userMessage("MapLoader"," START"); 
    }
  
    /**
     * helper method
     */
    private void setprop(String name,int idx) {
	colors[idx] = _svc.getColorProperty(name+"_color",Color.black);
	widths[idx] = _svc.getIntegerProperty(name+"_width",1);
    }

    /**
     * basic constructor
     */
    public MapLoader() {
	super();

	cb = new MsgCallback(this);

	colors = new Color[MapObjTag.MAP_MAX];
	widths = new int[MapObjTag.MAP_MAX];

	setprop("line",MAPLINE);
	setprop("wall",MAPWALL);
	setprop("circle",MAPCIRCLE);
	setprop("quad",MAPQUAD);
	setprop("tri",MAPTRIANGLE);
	setprop("door",MAPDOOR);
	setprop("swall",MAPSWALL);
	setprop("box",MAPBOX);
	setprop("poly",MAPPOLY);
    
	mapcmds = new Hashtable(); 
	mapcmds.put("map",new MapCmd());
	mapcmds.put("dimension",new DimCmd());
	mapcmds.put("line",new LineCmd());
	mapcmds.put("quad",new QuadCmd());
	mapcmds.put("tri",new TriCmd());
	mapcmds.put("circle",new CircleCmd());
	mapcmds.put("poly",new PolyCmd());
	mapcmds.put("wall",new WallCmd());
	mapcmds.put("door",new DoorCmd());
	mapcmds.put("end",new EndCmd());
    }
}
