// Copyright (c)1999-2001 by "GMD-AiS"
//  Full name: "GMD National Research Center for Information Technology -
//  Institute for Autonomous Intelligent Systems", in future
//  named "Fraunhofer Institute for Autonomous Intelligent Systems"
//
// This software is provided 'as is' by the above copyright holder without
// any explicit or implicit warranty and support.
//
// Within the granted license, the licensee is allowed to freely use
// and modify the software EXCLUSIVELY FOR academical, SCIENTIFIC, and/or
// educational PURPOSES. It is permitted to cite (in the common scientific
// sense) fragments of the code in scientific publications of the licensee,
// and also use modified or unmodified parts of the software in own
// research prototypes.
//
// Commerical use, as well as integration into hardware/software systems or
// other products, other then for aforementioned scientific purposes, is
// PROHIBITED WITHOUT EXPLICIT PERMISSION of the copyright holder.
//
// Prototyping software that makes use of parts of this code have to
// refer to the above copyright when given out to third parties by
// a line
//   "This software contains or uses code that is copyrighted
//    by the GMD National Research Center for Information Technology
//    (Fraunhofer Institute for Autonomous Intelligent Systems)"
// in the user visible part of the software (documentation, about box, etc.)
//
// The copyright holder provides the software 'as is' without any support
// (request for bugfixes, for instance), and without any implicit or explicit
// warranty. In particular, the copyright holder cannot be made liable
// for lack of certain features, for damages of any kind that might result
// from any proper or improper use of this software. This software is not
// to be used in safety-critical environments.
//
// Beyond this license, GMD-AiS appreciates, in the scientific sense,
// reports and code submissions of significant changes or improvements
// of the jFTA core software that might be integrated into a future
// version of this code. Such reports are entirely voluntary, though;
// they are not mandated by this license. Use the address jfta@borneo.gmd.de
// (in future jfta@borneo.ais.fhg.de) for submissions.

package jfta.demo.simrob;

import jfta.exception.*;
import jfta.tags.*;

/**
  * This tag is used for message exchange beween simserver and janitor
  * actors.
  * @author Holger Veit, Andre Schmitz, Frank Schoenherr
  * @version $Id: MsgTag.java,v 1.2 2001/06/21 14:57:19 veit Exp $
  */
public class MsgTag extends FTATag {

  /**
   * simulator message types
   */
  public final static int INVALID = 0;
  public final static int LOADMAP = 1;
  public final static int LIFTVEH = 2;
  public final static int DROPVEH = 3;
  public final static int CENTERVIEW = 4;
  public final static int INCTIME = 5;
  public final static int DECTIME = 6;
  public final static int SIMTIMEREAL = 7;
  public final static int SIMTIMECONST = 8;
  public final static int SIMTIMESET = 9;
  public final static int SIMHALT = 10;
  public final static int SIMCONTINUE = 11;
  public final static int NEWPOS = 12; 
  public final static int MOVE = 13;
  public final static int CLOSECOM = 14;
  public final static int ADDVEHICLE = 15;
  public final static int REMVEHICLE = 16;
  public final static int TERMINATE = 17;
  public final static int MAXSIMMSGTYPE = 18;

  /**
    * all MsgTags have store type "MsgTag"
    * @return the storetype for this tag
    */
  public String getStoreType() {
    return "jfta.demo.simrob.MsgTag";
  }

  /**
    * get the message type
    * @return the message type
    */
  public int getMsgType() {
    return INVALID;
  }

  /**
    * constructor
    */
  public MsgTag() {
    super();
  }
}
