// Copyright (c)1999-2001 by "GMD-AiS"
//  Full name: "GMD National Research Center for Information Technology -
//  Institute for Autonomous Intelligent Systems", in future
//  named "Fraunhofer Institute for Autonomous Intelligent Systems"
//
// This software is provided 'as is' by the above copyright holder without
// any explicit or implicit warranty and support.
//
// Within the granted license, the licensee is allowed to freely use
// and modify the software EXCLUSIVELY FOR academical, SCIENTIFIC, and/or
// educational PURPOSES. It is permitted to cite (in the common scientific
// sense) fragments of the code in scientific publications of the licensee,
// and also use modified or unmodified parts of the software in own
// research prototypes.
//
// Commerical use, as well as integration into hardware/software systems or
// other products, other then for aforementioned scientific purposes, is
// PROHIBITED WITHOUT EXPLICIT PERMISSION of the copyright holder.
//
// Prototyping software that makes use of parts of this code have to
// refer to the above copyright when given out to third parties by
// a line
//   "This software contains or uses code that is copyrighted
//    by the GMD National Research Center for Information Technology
//    (Fraunhofer Institute for Autonomous Intelligent Systems)"
// in the user visible part of the software (documentation, about box, etc.)
//
// The copyright holder provides the software 'as is' without any support
// (request for bugfixes, for instance), and without any implicit or explicit
// warranty. In particular, the copyright holder cannot be made liable
// for lack of certain features, for damages of any kind that might result
// from any proper or improper use of this software. This software is not
// to be used in safety-critical environments.
//
// Beyond this license, GMD-AiS appreciates, in the scientific sense,
// reports and code submissions of significant changes or improvements
// of the jFTA core software that might be integrated into a future
// version of this code. Such reports are entirely voluntary, though;
// they are not mandated by this license. Use the address jfta@borneo.gmd.de
// (in future jfta@borneo.ais.fhg.de) for submissions.

// $Id: TestServlet1.java,v 1.3 2001/06/21 14:57:24 veit Exp $

package jfta.http;

import java.net.*;
import java.io.*;
import java.util.*;

import jfta.exception.*;

public class TestServlet1 extends FTAServlet {

    /**
     * mandatory constructor
     */
    public TestServlet1() {
	super();
    }

    /**
     * reply method. Can be called either for toplevel
     * (head=/*.html) or lower levels
     * (tail=/*.html)
     */
    public FTAServletReply reply(FTAServletRequest req) {

	String head = req.getHead();
	String file = req.getTail();
	String page = req.getURL();
	//System.out.println("TestServlet1: head="+head+" tail="+file);

	// is a toplevel leafnode
	if (head.indexOf(".html") != -1)
	    file = head;

	// if a directory was requested, at least provide
	// the index.html file (no FTP style mode)
	if (file.indexOf(".html") == -1)
	    file = "/index.html";

	// accept index.html and test1.html
	if (file.equals("/index.html")) {
	    FTAHtmlFile f = new FTAHtmlFile("This is page "+page);
	    
	    f.text("This is the demo page at " + page);
	    f.p(" corresponding to the servlet " + toString() + ".");
	    f.text("There is also a link ");
	    f.anchor("/test1/test1.html","to another demo page");
	    f.p(" here (describing sample GET/POST forms).");

	    f.text("You can also locate the following resources:");
	    f.beginUL();
	    f.item("Online docs for ");
	    f.anchor("/docs/","jFTA");
	    f.item("Further verbal FTA ");
	    f.anchor("/fta/","information");
	    f.item();
	    f.anchor("/arc/","Robot Control Architectures (ARC) research team");
	    f.item();
	    f.anchor("/ais/","GMD Institute for Autonomous intelligent Systems (AiS)");
	    f.item();
	    f.anchor("/gmd/","GMD Research Center for Information Technology");
	    f.endUL();
	    return f.finish();
	} else if (file.equals("/test1.html")) {
	    FTAHtmlFile f = new FTAHtmlFile("This is page /test1/test1.html");
	    f.br("This is the demo page at " + page);
	    f.p(" corresponding to the servlet " + toString() + ".");
	    f.p("Fill in one of the following forms:");
	    f.hr();
	    f.beginForm("/cgi-bin/test1.svl");
	    f.text("Name: "); f.inputField(10,"name","");
	    f.p();
	    f.text("Password: "); f.passwordField(10,"password","");
	    f.hiddenField(10,"method","POST");
	    f.p();
	    f.submitButton("Submit 1");
	    f.endForm();
	    f.hr();
	    f.beginForm("GET","/cgi-bin/test1.svl");
	    f.text("Other Name: "); f.inputField(10,"name","");
	    f.p();
	    f.text("Other Password: "); f.passwordField(10,"password","");
	    f.hiddenField(10,"method","GET");
	    f.p();
	    f.submitButton("Submit 2");
	    f.endForm();
	    f.hr();
	    return f.finish("/test1","TestServlet1");
	} else
	    return FTAErrorReply.error404();
    }
}
