// Copyright (c)1999-2001 by "GMD-AiS"
//  Full name: "GMD National Research Center for Information Technology -
//  Institute for Autonomous Intelligent Systems", in future
//  named "Fraunhofer Institute for Autonomous Intelligent Systems"
//
// This software is provided 'as is' by the above copyright holder without
// any explicit or implicit warranty and support.
//
// Within the granted license, the licensee is allowed to freely use
// and modify the software EXCLUSIVELY FOR academical, SCIENTIFIC, and/or
// educational PURPOSES. It is permitted to cite (in the common scientific
// sense) fragments of the code in scientific publications of the licensee,
// and also use modified or unmodified parts of the software in own
// research prototypes.
//
// Commerical use, as well as integration into hardware/software systems or
// other products, other then for aforementioned scientific purposes, is
// PROHIBITED WITHOUT EXPLICIT PERMISSION of the copyright holder.
//
// Prototyping software that makes use of parts of this code have to
// refer to the above copyright when given out to third parties by
// a line
//   "This software contains or uses code that is copyrighted
//    by the GMD National Research Center for Information Technology
//    (Fraunhofer Institute for Autonomous Intelligent Systems)"
// in the user visible part of the software (documentation, about box, etc.)
//
// The copyright holder provides the software 'as is' without any support
// (request for bugfixes, for instance), and without any implicit or explicit
// warranty. In particular, the copyright holder cannot be made liable
// for lack of certain features, for damages of any kind that might result
// from any proper or improper use of this software. This software is not
// to be used in safety-critical environments.
//
// Beyond this license, GMD-AiS appreciates, in the scientific sense,
// reports and code submissions of significant changes or improvements
// of the jFTA core software that might be integrated into a future
// version of this code. Such reports are entirely voluntary, though;
// they are not mandated by this license. Use the address jfta@borneo.gmd.de
// (in future jfta@borneo.ais.fhg.de) for submissions.

//Source file: $Id: FTASysTag.java,v 1.7 2001/06/21 14:57:27 veit Exp $

package jfta.tags;

import java.net.*;
import java.io.Serializable;

import jfta.base.*;
import jfta.http.*;
import jfta.bootstrap.*;
import jfta.exception.*;
import jfta.system.*;

/**
 * This is an abstract base class
 * @author Holger Veit
 * @version $Id: FTASysTag.java,v 1.7 2001/06/21 14:57:27 veit Exp $
 * @since JFTA1.0
 */
public class FTASysTag extends FTATag
    implements Serializable,FTAServletI {

    public final static int HOST = FTASysTagboard.HOST;
    public final static int TB = FTASysTagboard.TB;
    public final static int EN = FTASysTagboard.EN;

    /**
     */
    protected int _objnum;

    /**
     */
    protected int _objtype;

    /**
     */
    protected String _hostname;

    /**
     */
    protected String _logname;
    
    /**
     * Constructor for the tag. This is used internally only, 
     * it cannot be used to produce a usable tag.
     */
    public FTASysTag() {}
  
    /**
     * Constructor. 
     * @param hostname the name of the described host
     */
    public FTASysTag(int objnum,int objtype,
		     String hostname,String logname) {
	super();
	_objnum = objnum;
	_objtype = objtype;
	_hostname = hostname;
	_logname = logname;
    }

    /**
     * return object number
     */
    public final int getObjnum() {
	return _objnum;
    }

    public final int getObjType() {
	return _objtype;
    }

    /**
     * get the host name
     * @return the hostname
     */
    public final String getHostname() {
	return _hostname;
    }

    /**
     * get the logical name
     * @return the logical name
     */
    public final String getLogname() {
	return _logname;
    }

    /**
     * provide HTML Information about this object and 
     * its contained objects
     */
    public FTAServletReply reply(FTAServletRequest req) {
	return 
	    FTAServletReply.defaultReply(this,
					 Integer.toString(_objnum));
    }
}

/*
 * Local variables: 
 * tab-width: 8
 * c-basic-offset: 4
 * End: 
 */
